﻿Type=StaticCode
Version=6
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
' Version 2.1
'		Changed the scope of FILTER_BITMAP_FLAG to Public
' Version 2.0
'		Modified FitCenterBitmap to allow over draw

'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Public Const FILTER_BITMAP_FLAG As Int = 2
End Sub

Public Sub SetPadding(vw As View, left As Int, right As Int, top As Int, bottom As Int)
	Dim JO As JavaObject = vw
	JO.RunMethod("setPadding", Array As Object(left, right , top, bottom))
End Sub


#Region  ProgressBar Gradient 

' USES: SetProgressDrawable
' Orientation can be "TOP_BOTTOM", etc.
Public Sub SetProgressBarGradient(ProgBar As ProgressBar, Orientation As String, BaseColor As Int, FirstColor As Int, LastColor As Int, CornerRadius As Int)

   Dim gd As GradientDrawable
   gd.Initialize(Orientation, Array As Int(FirstColor, LastColor))
   gd.CornerRadius = CornerRadius
   Dim cd As ColorDrawable
   cd.Initialize(BaseColor, CornerRadius)
   SetProgressDrawable(ProgBar, gd, cd)
End Sub

Private Sub SetProgressDrawable(p As ProgressBar, drawable As Object, backgroundDrawable As Object)

   Dim r As Reflector
   Dim ClipDrawable As Object
   ClipDrawable = r.CreateObject2("android.graphics.drawable.ClipDrawable", _
      Array As Object(drawable, Gravity.LEFT, 1), _
      Array As String("android.graphics.drawable.Drawable", "java.lang.int", "java.lang.int"))
   r.Target = p
   r.Target = r.RunMethod("getProgressDrawable") 'Gets the layerDrawable
   r.RunMethod4("setDrawableByLayerId", _
      Array As Object(16908288, backgroundDrawable), _
      Array As String("java.lang.int", "android.graphics.drawable.Drawable"))
   r.RunMethod4("setDrawableByLayerId", _
      Array As Object(r.GetStaticField("android.R$id", "progress"), ClipDrawable), _
      Array As String("java.lang.int", "android.graphics.drawable.Drawable"))
End Sub

#End Region

' Resizes a bitmap to be centered in a ImageView.
Sub ResizeBmp(bmp As Bitmap, ImageViewWidth As Int, ImageViewHeight As Int) As Bitmap 'ignore
' Uses CreateScaledBitmap
	Dim ScaleFactor As Float
	ScaleFactor = Min(ImageViewWidth / bmp.Width, ImageViewHeight / bmp.Height)
	bmp = CreateScaledBitmap(bmp, bmp.Width * ScaleFactor, bmp.Height * ScaleFactor, True)
	Return bmp
End Sub

Sub CreateScaledBitmap(Original As Bitmap, Width As Int, Height As Int, Filter As Boolean) As Bitmap
  Dim r As Reflector
  Dim b As Bitmap
  b = r.RunStaticMethod("android.graphics.Bitmap", "createScaledBitmap", _
      Array As Object(Original, Width, Height, Filter), _
      Array As String("android.graphics.Bitmap", "java.lang.int", "java.lang.int", "java.lang.boolean"))
  Return b
End Sub

' Transforms a Bitmap to an array of bytes
Sub GetImgBytes(bmp As Bitmap) As Byte()

	Dim out As OutputStream
	Dim data() As Byte

	out.InitializeToBytesArray(1)
	bmp.WriteToStream(out,100,"PNG")
	data = out.ToBytesArray

	out.Close
	Return data 
End Sub

' Reads a Bitmap from file to an array of bytes
Public Sub GetImgBytesFromFile(Dir As String, FileName As String) As Byte()

	Dim Buffer() As Byte
	Dim InStream As InputStream
	InStream = File.OpenInput(Dir, FileName)
	Dim OutputStream1 As OutputStream
	OutputStream1.InitializeToBytesArray(0)
	File.Copy2(InStream, OutputStream1)
	Buffer = OutputStream1.ToBytesArray
	OutputStream1.Close
	
	Return Buffer
End Sub

Sub SetIVBitmap(IV As ImageView, bmp As Bitmap) 'ignore
	Dim ScaleFactor As Float
	ScaleFactor = Min(IV.Width / bmp.Width, IV.Height / bmp.Height)
	bmp = CreateScaledBitmap(bmp, bmp.Width * ScaleFactor, bmp.Height * ScaleFactor, True)
	IV.Gravity = Gravity.CENTER
	IV.Bitmap = bmp
End Sub

Sub Get64String(bmp As Bitmap) As String 'ignore
	Dim su As StringUtils
	Dim BmpBytes() As Byte = GetImgBytes(bmp)
	Return su.EncodeBase64(BmpBytes)
End Sub

Sub GetBmpFrom64String(BmpString As String) As Bitmap 'ignore
	Dim su As StringUtils
	Dim BmpBytes() As Byte = su.DecodeBase64(BmpString)
	Dim in As InputStream
	in.InitializeFromBytesArray(BmpBytes, 0, BmpBytes.Length)
	Dim bmp As Bitmap
	bmp.Initialize2(in)
	in.Close
	Return bmp
End Sub


Sub FitCenterBitmap(Imv As ImageView, bmp As Bitmap, ClearBefore As Boolean) 'ignore
	If ClearBefore Then Imv.Background = Null

	Private cvs As Canvas
	cvs.Initialize(Imv)

	SetAntiAlias(cvs, FILTER_BITMAP_FLAG)

	Dim rectDest As Rect
	Dim delta As Int
	If bmp.Width / bmp.Height > Imv.Width / Imv.Height Then
		delta = (Imv.Height - bmp.Height / bmp.Width * Imv.Width) / 2
		rectDest.Initialize(0, delta,Imv.Width, Imv.Height - delta)
	Else
		delta = (Imv.Width - bmp.Width / bmp.Height * Imv.Height) / 2
		rectDest.Initialize(delta, 0, Imv.Width - delta, Imv.Height)
	End If
	cvs.DrawBitmap(bmp, Null, rectDest)
	Imv.Invalidate
End Sub

Sub SetAntiAlias (c As Canvas, FilterFlag As Int)
   Dim r As Reflector
   Dim NativeCanvas As Object
   r.Target = c
   NativeCanvas = r.GetField("canvas")
   Dim PaintFlagsDrawFilter As Object
   PaintFlagsDrawFilter = r.CreateObject2("android.graphics.PaintFlagsDrawFilter", _
      Array As Object(0, FilterFlag), Array As String("java.lang.int", "java.lang.int"))
   r.Target = NativeCanvas
   r.RunMethod4("setDrawFilter", Array As Object(PaintFlagsDrawFilter), Array As String("android.graphics.DrawFilter"))
End Sub

Sub ButtonSetStateListDrawable(btnBitmap As Button, EnabledBitmap As Bitmap, PressedBitmap As Bitmap, DisabledBitmap As Bitmap) 'ignore
	' Define a bitmap for Enabled state
	Dim bdwEnabled As BitmapDrawable
	bdwEnabled.Initialize(EnabledBitmap)
	
	' Define a bitmap for Pressed state
	Dim bdwPressed As BitmapDrawable
	bdwPressed.Initialize(PressedBitmap)

	' Define a bitmap for Disabled state
	Dim bdwDisabled As BitmapDrawable
	bdwDisabled.Initialize(DisabledBitmap)

	' Define a StateListDrawable
	Dim stdBitmap As StateListDrawable
	stdBitmap.Initialize
	Dim states(2) As Int
	states(0) = stdBitmap.state_enabled
	states(1) = -stdBitmap.state_pressed
	stdBitmap.addState2(states, bdwEnabled)
	Dim states(1) As Int
	states(0) = stdBitmap.state_enabled
	stdBitmap.addState2(states, bdwPressed)
	Dim states(1) As Int
	states(0) = stdBitmap.State_Disabled
	stdBitmap.addState2(states, bdwDisabled)
	
	' Set stdBitmap to button btnBitmap
	btnBitmap.Background = stdBitmap
End Sub

